/**
  NyARToolkit for proce55ing/1.0.0
  (c)2008-2011 nyatla
  airmail(at)ebony.plala.or.jp
  
  This sample proglam handles 2 ARToolKit marker.
  The markers are "patt.hiro" and "patt.kanji"
  2 differents 3D .obj models textured
*/

// Librairies
import processing.video.*;
import jp.nyatla.nyar4psg.*;
import saito.objloader.*;

// Variables camera + nyar 
Capture cam;
MultiMarker nya;

// déclaration objet 3D
OBJModel stone;
OBJModel box;
OBJModel annie ;

// Déclaration variable nombre de frames à charger 
OBJModel[] anim;
int animFrames = 20;
int animFrame;
// Déclaration variable Booléenne (George Boole) vrai/faux
boolean animOn= true;
// Déclaration variable décimale, nombre à virgule x.xxxx, valeur de départ 0.0
// float turn = 0.0;
// float prevangle = 0.0;

// Gestion du rendu, texture, maillage
// variables de type booléenne true/false
boolean bTexture = true;
boolean bStroke = false;
boolean bMaterial = true;

// int Width Height
int arWidth = 640;
int arHeight = 480;

void setup() {
  size(1280,720,OPENGL);
  frameRate(30);
  colorMode(RGB, 100);
  
  // pas de curseur  
  noCursor();
  
  println(MultiMarker.VERSION);  
  cam=new Capture(this,1280,720);
  nya=new MultiMarker(this,width,height,"camera_para.dat",NyAR4PsgConfig.CONFIG_PSG);
  nya.addARMarker("data/patt.hiro",80);//id=0
  nya.addARMarker("data/patt.kanji",80);//id=1
  nya.addARMarker("data/samarker16.pat",80);//id=2
  

// importation du modèle 3D 1
  stone = new OBJModel(this, "data/stone.obj", "absolute", TRIANGLES);
  stone.enableDebug();
// taille du modèle
  stone.scale(20);

// importation du modèle 3D 2
  box = new OBJModel(this, "data/box.obj", "absolute", TRIANGLES);
  box.enableDebug();
// taille du modèle
  box.scale(20);
 
// démarrage caméra 
  cam.start();
 
// animation tableau   
  int j;
  String filename = "";
  // initialisation du tableau d'objet contenant animFrames=20 frames
  anim = new OBJModel[animFrames];
  // chargement des différents objets
  for(j = 1; j <= animFrames; j++){
    if(j < 10){
      filename = "shootinannie-superlowpoly-tri_00000" + j + ".obj";
     }else{
       filename = "shootinannie-superlowpoly-tri_0000" + j + ".obj";
     }
     anim[j-1] = new OBJModel(this, filename, "relative", TRIANGLES);
     anim[j-1].enableDebug();
     anim[j-1].scale(15);
     anim[j-1].translateToCenter();
     //anim[j-1].enableTexture();
   }
}


void draw()
{
  if (cam.available() !=true) {
      return;
  }
  cam.read();
  nya.detect(cam);
  background(0);
  image(cam, 0, 0, width,height);
  nya.drawBackground(cam);
  PImage cSmall = cam.get();
    cSmall.resize(arWidth, arHeight);
  for(int i=0;i<1;i++){
    if((!nya.isExistMarker(0))){
      continue;
    }
    nya.beginTransform(i);
    noStroke();
    translate(0,0,0);
    stone.draw();
    nya.endTransform();
  }
   for(int i=1;i<2;i++){
    if((!nya.isExistMarker(1))){
      continue;
    }
    nya.beginTransform(i);
    noStroke();
    translate(0,0,20);
    box.draw();
    nya.endTransform();
  }
  for(int i=2;i<3;i++){
    if((!nya.isExistMarker(2))){
      animOn = true;
      continue;
    }
    nya.beginTransform(i);
    noStroke();
    translate(0,0,20);
    rotateX(radians(-90));
    rotateY(PI);
    
    // annie.draw();
    // animation de l'objet Annie
    if(animOn){
       anim[animFrame].draw();

       animFrame++;
       if(animFrame == animFrames){
          animFrame = 0;
          }
        }else{  
          anim[17].draw();
        }
    nya.endTransform();
  }
}


